"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.ipfsPlugin = exports.IpfsPlugin = void 0;
var resolvers_1 = require("./resolvers");
var w3_1 = require("./w3");
var core_js_1 = require("@web3api/core-js");
var abort_controller_1 = __importDefault(require("abort-controller"));
// eslint-disable-next-line @typescript-eslint/no-var-requires, @typescript-eslint/no-require-imports
var isIPFS = require("is-ipfs");
// eslint-disable-next-line @typescript-eslint/no-var-requires, @typescript-eslint/no-require-imports, @typescript-eslint/naming-convention
var createIpfsClient = require("@dorgjelli-test/ipfs-http-client-lite");
var IpfsPlugin = /** @class */ (function (_super) {
    __extends(IpfsPlugin, _super);
    function IpfsPlugin(_config) {
        var _this = _super.call(this) || this;
        _this._config = _config;
        _this.setProvider(_this._config.provider);
        return _this;
    }
    IpfsPlugin.manifest = function () {
        return w3_1.manifest;
    };
    IpfsPlugin.isCID = function (cid) {
        return isIPFS.cid(cid) || isIPFS.cidPath(cid) || isIPFS.ipfsPath(cid);
    };
    IpfsPlugin.prototype.getModules = function (_client) {
        return {
            query: resolvers_1.query(this),
            mutation: resolvers_1.mutation(this),
        };
    };
    IpfsPlugin.prototype.setProvider = function (provider) {
        this._config.provider = provider;
        this._ipfs = createIpfsClient(provider);
    };
    IpfsPlugin.prototype.add = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._ipfs.add(data)];
                    case 1:
                        result = _a.sent();
                        if (result.length === 0) {
                            throw Error("IpfsPlugin:add failed to add contents. Result of length 0 returned.");
                        }
                        return [2 /*return*/, result[0]];
                }
            });
        });
    };
    IpfsPlugin.prototype.cat = function (cid, options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._execWithOptions("cat", function (ipfs, _provider, options) {
                            return ipfs.cat(cid, options);
                        }, options)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    IpfsPlugin.prototype.catToString = function (cid, options) {
        return __awaiter(this, void 0, void 0, function () {
            var buffer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.cat(cid, options)];
                    case 1:
                        buffer = _a.sent();
                        return [2 /*return*/, buffer.toString("utf-8")];
                }
            });
        });
    };
    IpfsPlugin.prototype.resolve = function (cid, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._execWithOptions("resolve", function (ipfs, provider, options) { return __awaiter(_this, void 0, void 0, function () {
                            var path;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, ipfs.resolve(cid, options)];
                                    case 1:
                                        path = (_a.sent()).path;
                                        return [2 /*return*/, {
                                                cid: path,
                                                provider: provider,
                                            }];
                                }
                            });
                        }); }, options)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    IpfsPlugin.prototype._execWithOptions = function (operation, exec, options) {
        return __awaiter(this, void 0, void 0, function () {
            var timeout, providerOverride, ipfs, provider, fallbackIdx, complete, result, _loop_1, this_1, ipfs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!options) return [3 /*break*/, 5];
                        timeout = options.timeout || 0;
                        providerOverride = options.provider;
                        if (!(timeout > 0)) return [3 /*break*/, 4];
                        ipfs = this._ipfs;
                        provider = providerOverride || this._config.provider;
                        fallbackIdx = -1;
                        complete = false;
                        result = undefined;
                        _loop_1 = function () {
                            var controller, timer, e_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        controller = new abort_controller_1.default();
                                        timer = setTimeout(function () { return controller.abort(); }, timeout);
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, exec(ipfs, provider, { signal: controller.signal })];
                                    case 2:
                                        result = _a.sent();
                                        return [3 /*break*/, 4];
                                    case 3:
                                        e_1 = _a.sent();
                                        return [3 /*break*/, 4];
                                    case 4:
                                        clearTimeout(timer);
                                        if (this_1._config.fallbackProviders && !providerOverride) {
                                            // Retry with a new provider
                                            fallbackIdx += 1;
                                            if (fallbackIdx >= this_1._config.fallbackProviders.length) {
                                                complete = true;
                                            }
                                            else {
                                                provider = this_1._config.fallbackProviders[fallbackIdx];
                                                ipfs = createIpfsClient(provider);
                                            }
                                        }
                                        else {
                                            complete = true;
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _a.label = 1;
                    case 1:
                        if (!!complete) return [3 /*break*/, 3];
                        return [5 /*yield**/, _loop_1()];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 3:
                        if (!result) {
                            throw Error(operation + ": Timeout has been exceeded, and all providers have been exhausted.\nTimeout: " + timeout + "\nProviders: " + (providerOverride
                                ? [providerOverride]
                                : __spread([
                                    this._config.provider
                                ], (this._config.fallbackProviders || []))));
                        }
                        return [2 /*return*/, result];
                    case 4:
                        if (providerOverride) {
                            ipfs = createIpfsClient(providerOverride);
                            return [2 /*return*/, exec(ipfs, providerOverride, undefined)];
                        }
                        _a.label = 5;
                    case 5: 
                    // Default behavior
                    return [2 /*return*/, exec(this._ipfs, this._config.provider, undefined)];
                }
            });
        });
    };
    return IpfsPlugin;
}(core_js_1.Plugin));
exports.IpfsPlugin = IpfsPlugin;
exports.ipfsPlugin = function (opts) {
    return {
        factory: function () { return new IpfsPlugin(opts); },
        manifest: w3_1.manifest,
    };
};
exports.plugin = exports.ipfsPlugin;
//# sourceMappingURL=index.js.map